searchNodes=[{"doc":"Freedom Formatter is a fork of Elixir's code formatter, with added freedom.It respects .formatter.exs and supports all features of the standard code formatter, as well as additional features unlikely to arrive soon in core Elixir.UsageInstall:{:freedom_formatter, &quot;~&gt; 1.0&quot;, only: :dev}Run:mix fformatWhyElixir's code formatter does not intend to support trailing commas, or indeed any additional settings, until at least January 2019. See Elixir issues #7689 and #6646 for more information.Thanks to software freedom, we can use tomorrow's formatter today.Project GoalsTo provide a compatible alternative to the Elixir formatter, available separately from the core Elixir distributionTo allow developers and teams to benefit from standardized code formatting while retaining a style they find more productiveTo be a testbed for new formatting features and options, maintaining the easiest possible path to possible inclusion in core Elixir.Added featuresFreedom Formatter supports all Elixir's standard code formatting options, as well as::trailing_comma - if set true, multi-line list, map, and struct literals will include a trailing comma after the last item or pair in the data structure. Does not affect argument lists, tuples, or lists/maps/structs rendered on a single line.ThanksThanks to José Valim for hacking together a code formatter and getting it almost perfect. :)","ref":"FreedomFormatter.html","title":"FreedomFormatter","type":"module"},{"doc":"Formats a file.See format_string!/2 for more information on code formatting and available options.","ref":"FreedomFormatter.html#format_file!/2","title":"FreedomFormatter.format_file!/2","type":"function"},{"doc":"Formats the given code string.The formatter receives a string representing Elixir code and returns iodata representing the formatted code according to pre-defined rules.Options:file - the file which contains the string, used for error reporting:line - the line the string starts, used for error reporting:line_length - the line length to aim for when formatting the document. Defaults to 98.:locals_without_parens - a keyword list of name and arity pairs that should be kept without parens whenever possible. The arity may be the atom :*, which implies all arities of that name. The formatter already includes a list of functions and this option augments this list.:rename_deprecated_at - rename all known deprecated functions at the given version to their non-deprecated equivalent. It expects a valid Version which is usually the minimum Elixir version supported by the project.:trailing_comma - if set true, multi-line list, map, and struct literals will include a trailing comma after the last item or pair in the data structure. Does not affect argument lists, tuples, or lists/maps/structs rendered on a single line.Design principlesThe formatter was designed under three principles.First, the formatter never changes the semantics of the code by default. This means the input AST and the output AST are equivalent. Optional behaviour, such as :rename_deprecated_at, is allowed to break this guarantee.The second principle is to provide as little configuration as possible. This eases the formatter adoption by removing contention points while making sure a single style is followed consistently by the community as a whole.The formatter does not hard code names. The formatter will not behave specially because a function is named defmodule, def, etc. This principle mirrors Elixir's goal of being an extensible language where developers can extend the language with new constructs as if they were part of the language. When it is absolutely necessary to change behaviour based on the name, this behaviour should be configurable, such as the :locals_without_parens option.Running the formatterWhile the formatter attempts to fit the most it can on a single line, in many situations such may not be possible, often causing line breaks to be introduced in the code.In some cases, this may lead to undesired formatting and it is often best to adjust the formatted output. To put it in other words: some code generated by the formatter may not be aesthetically pleasing and they require explicit intervention from the developer. That's why we do not recommend to run the formatter blindly in an existing codebase. Instead you should format and sanity check each formatted file.Let's see some examples. The code below:&quot;this is a very long string ... \#{inspect(some_value)}&quot;may be formatted as:&quot;this is a very long string ... \#{ inspect(some_value) }&quot;This happens because the only place the formatter can introduce a new line without changing the code semantics is in the interpolation. In those scenarios, we recommend developers to directly adjust the code. Here we can use the binary concatenation operator &lt;&gt;/2:&quot;this is a very long string &quot; &lt;&gt; &quot;... \#{inspect(some_value)}&quot;The string concatenation makes the code fit on a single line and also gives more options to the formatter.A similar example is when the formatter breaks a function definition over multiple clauses:def my_function( %User{name: name, age: age, ...}, arg1, arg2 ) do ... endWhile the code above is completely valid, you may prefer to match on the struct variables inside the function body in order to keep the definition on a single line:def my_function(%User{} = user, arg1, arg2) do %{name: name, age: age, ...} = user ... endIn some situations, you can use the fact the formatter does not generate elegant code as a hint for refactoring. Take this code:def board?(board_id, %User{} = user, available_permissions, required_permissions) do Tracker.OrganizationMembers.user_in_organization?(user.id, board.organization_id) and required_permissions == Enum.to_list(MapSet.intersection(MapSet.new(required_permissions), MapSet.new(available_permissions))) endThe code above has very long lines and running the formatter is not going to address this issue. In fact, the formatter may make it more obvious that you have complex expressions:def board?(board_id, %User{} = user, available_permissions, required_permissions) do Tracker.OrganizationMembers.user_in_organization?(user.id, board.organization_id) and required_permissions == Enum.to_list( MapSet.intersection( MapSet.new(required_permissions), MapSet.new(available_permissions) ) ) endTake such cases as a suggestion that your code should be refactored:def board?(board_id, %User{} = user, available_permissions, required_permissions) do Tracker.OrganizationMembers.user_in_organization?(user.id, board.organization_id) and matching_permissions?(required_permissions, available_permissions) end defp matching_permissions?(required_permissions, available_permissions) do intersection = required_permissions |&gt; MapSet.new() |&gt; MapSet.intersection(MapSet.new(available_permissions)) |&gt; Enum.to_list() required_permissions == intersection endTo sum it up: since the formatter cannot change the semantics of your code, sometimes it is necessary to tweak or refactor the code to get optimal formatting. To help better understand how to control the formatter, we describe in the next sections the cases where the formatter keeps the user encoding and how to control multiline expressions.Keeping user's formattingThe formatter respects the input format in some cases. Those are listed below:Insignificant digits in numbers are kept as is. The formatter however always inserts underscores for decimal numbers with more than 5 digits and converts hexadecimal digits to uppercaseStrings, charlists, atoms and sigils are kept as is. No character is automatically escaped or unescaped. The choice of delimiter is also respected from the inputNewlines inside blocks are kept as in the input except for:expressions that take multiple lines will always have an empty line before and after and 2) empty lines are always squeezed together into a single empty lineThe choice between :do keyword and do/end blocks is left to the userLists, tuples, bitstrings, maps, structs and function calls will be broken into multiple lines if they are followed by a newline in the opening bracket and preceded by a new line in the closing bracketPipeline operators, like |&gt; and others with the same precedence, will span multiple lines if they spanned multiple lines in the inputThe behaviours above are not guaranteed. We may remove or add new rules in the future. The goal of documenting them is to provide better understanding on what to expect from the formatter.Multi-line lists, maps, tuples, etcYou can force lists, tuples, bitstrings, maps, structs and function calls to have one entry per line by adding a newline after the opening bracket and a new line before the closing bracket lines. For example:[ foo, bar ]If there are no newlines around the brackets, then the formatter will try to fit everything on a single line, such that the snippet below[foo, bar]will be formatted as[foo, bar]You can also force function calls and keywords to be rendered on multiple lines by having each entry on its own line:defstruct name: nil, age: 0The code above will be kept with one keyword entry per line by the formatter. To avoid that, just squash everything into a single line.Parens and no parens in function callsElixir has two syntaxes for function calls. With parens and no parens. By default, Elixir will add parens to all calls except for:calls that have do/end blockslocal calls without parens where the name and arity of the local call is also listed under :locals_without_parens (except for calls with arity 0, where the compiler always require parens)The choice of parens and no parens also affects indentation. When a function call with parens doesn't fit on the same line, the formatter introduces a newline around parens and indents the arguments with two spaces:some_call( arg1, arg2, arg3 )On the other hand, function calls without parens are always indented by the function call length itself, like this:some_call arg1, arg2, arg3If the last argument is a data structure, such as maps and lists, and the beginning of the data structure fits on the same line as the function call, then no indentation happens, this allows code like this:Enum.reduce(some_collection, initial_value, fn element, acc -&gt; # code end) some_funtion_without_parens %{ foo: :bar, baz: :bat }Code commentsThe formatter also handles code comments in a way to guarantee a space is always added between the beginning of the comment (#) and the next character.The formatter also extracts all trailing comments to their previous line. For example, the code belowhello #worldwill be rewritten to# world helloBecause code comments are handled apart from the code representation (AST), there are some situations where code comments are seen as ambiguous by the code formatter. For example, the comment in the anonymous function belowfn arg1 -&gt; body1 # comment arg2 -&gt; body2 endand in this onefn arg1 -&gt; body1 # comment arg2 -&gt; body2 endare considered equivalent (the nesting is discarded alongside most of user formatting). In such cases, the code formatter will always format to the latter.","ref":"FreedomFormatter.html#format_string!/2","title":"FreedomFormatter.format_string!/2","type":"function"},{"doc":"Formats the given files and patterns, with added freedom.mix fformat mix.exs &quot;lib/**/*.{ex,exs}&quot; &quot;test/**/*.{ex,exs}&quot;If any of the files is -, then the output is read from stdin and written to stdout.Formatting optionsThe formatter will read a .formatter.exs in the current directory for formatter configuration. Evaluating this file should return a keyword list.Here is an example .formatter.exs that works as a starting point:[ inputs: [&quot;{mix,.formatter}.exs&quot;, &quot;{config,lib,test}/**/*.{ex,exs}&quot;] ]Besides the options listed in FreedomFormatter.format_string!/2, the .formatter.exs supports the following options::inputs (a list of paths and patterns) - specifies the default inputs to be used by this task. For example, [&quot;mix.exs&quot;, &quot;{config,lib,test}/**/*.{ex,exs}&quot;].:subdirectories (a list of paths and patterns) - specifies subdirectories that have their own formatting rules. Each subdirectory should have a .formatter.exs that configures how entries in that subdirectory should be formatted as. Configuration between .formatter.exs are not shared nor inherited. If a .formatter.exs lists &quot;lib/app&quot; as a subdirectory, the rules in .formatter.exs won't be available in lib/app/.formatter.exs. Note that the parent .formatter.exs must not specify files inside the &quot;lib/app&quot; subdirectory in its :inputs configuration. If this happens, the behaviour of which formatter configuration will be picked is unspecified.:import_deps (a list of dependencies as atoms) - specifies a list of dependencies whose formatter configuration will be imported. When specified, the formatter should run in the same directory as the mix.exs file that defines those dependencies. See the &quot;Importing dependencies configuration&quot; section below for more information.:export (a keyword list) - specifies formatter configuration to be exported. See the &quot;Importing dependencies configuration&quot; section below.Task-specific options--check-formatted - check that the file is already formatted. This is useful in pre-commit hooks and CI scripts if you want to reject contributions with unformatted code. However keep in mind that the formatted output may differ between Elixir versions as improvements and fixes are applied to the formatter.--check-equivalent - check if the files after formatting have the same AST as before formatting. If the ASTs are not equivalent, it is a bug in the code formatter. This option is recommended if you are automatically formatting files.--dry-run - do not save files after formatting.--dot-formatter - path to the file with formatter configuration. Defaults to .formatter.exs if one is available. See the &quot;.formatter.exs&quot; section for more information.If any of the --check-* flags are given and a check fails, the formatted contents won't be written to disk nor printed to standard output.When to format codeWe recommend developers to format code directly in their editors, either automatically when saving a file or via an explicit command or key binding. If such option is not yet available in your editor of choice, adding the required integration is usually a matter of invoking:cd $project &amp;&amp; mix fformat $filewhere $file refers to the current file and $project is the root of your project.It is also possible to format code across the whole project by passing a list of patterns and files to mix fformat, as shown at the top of this task documentation. This list can also be set in the .formatter.exs under the :inputs key.Importing dependencies configurationThis task supports importing formatter configuration from dependencies.A dependency that wants to export formatter configuration needs to have a .formatter.exs file at the root of the project. In this file, the dependency can export a :export option with configuration to export. For now, only one option is supported under :export: :locals_without_parens (whose value has the same shape as the value of the :locals_without_parens in Code.format_string!/2).The functions listed under :locals_without_parens in the :export option of a dependency can be imported in a project by listing that dependency in the :import_deps option of the formatter configuration file of the project.For example, consider I have a project my_app that depends on my_dep. my_dep wants to export some configuration, so my_dep/.formatter.exs would look like this:# my_dep/.formatter.exs [ # Regular formatter configuration for my_dep # ... export: [ locals_without_parens: [some_dsl_call: 2, some_dsl_call: 3] ] ]In order to import configuration, my_app's .formatter.exs would look like this:# my_app/.formatter.exs [ import_deps: [:my_dep] ]","ref":"Mix.Tasks.Fformat.html","title":"Mix.Tasks.Fformat","type":"task"},{"doc":"Returns formatter options to be used for the given file.","ref":"Mix.Tasks.Fformat.html#formatter_opts_for_file/2","title":"Mix.Tasks.Fformat.formatter_opts_for_file/2","type":"function"},{"doc":"","ref":"Mix.Tasks.Fformat.html#read_manifest/1","title":"Mix.Tasks.Fformat.read_manifest/1","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Fformat.html#run/1","title":"Mix.Tasks.Fformat.run/1","type":"function"}]